!
!     CalculiX - 3-dimensional finite element program
!              Copyright (C) 1998-2005 Guido Dhondt
!
!     This program is free software; you can redistribute it and/or
!     modify it under the terms of the GNU General Public License as
!     published by the Free Software Foundation(version 2);
!     
!
!     This program is distributed in the hope that it will be useful,
!     but WITHOUT ANY WARRANTY; without even the implied warranty of 
!     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
!     GNU General Public License for more details.
!
!     You should have received a copy of the GNU General Public License
!     along with this program; if not, write to the Free Software
!     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
      subroutine dynsolv(b,z,d,zeta,nev,neq,tinc,jinc,jout,vold,
     &  xforcold,nodeforc,ndirforc,xforc,iamforc,nforc,xloadold,xload,
     &  iamload,nelemload,sideload,nload,
     &  t1old,t1,iamt1,nk,amta,namta,nam,ampli,aa,bb,bj,v,
     &  nodeboun,ndirboun,xboun,nboun,ipompc,nodempc,coefmpc,labmpc,
     &  nmpc,nactdof,iperturb,nmethod,co,kon,ipkon,lakon,
     &  ne,stn,stx,elcon,nelcon,rhcon,nrhcon,alcon,
     &  nalcon,alzero,ielmat,ielorien,norien,orab,ntmat_,
     &  t0,ithermal,kode,cv,cd,inum,prestr,iprestr,
     &  ikmpc,ilmpc,ikboun,ilboun,filab,
     &  eme,een,sti,f,fn,xforcact,xloadact,t1act,
     &  xbounold,xbounact,iamboun,iexpl,plicon,nplicon,plkcon,nplkcon,
     &  xstateini,xstiff,xstate,npmat_,epn,matname,mint_,ncmat_,nstate_,
     &  stiini,vini,ener,enern,xstaten,ttime,eei,enerini,cocon,
     &  ncocon,set,nset,istartset,iendset,ialset,nprint,prlab,prset,
     &  qfx,qfn,trab,inotr,ntrans,fmpc,veold,cbody,ibody,xbody,nbody,
     &  xbodyold,xbodyact,ipobody,cgr)
!
!     dynamic solution using modal decomposition
!
      implicit none
!
      character*6 filab(*)
      character*6 prlab(*)
      character*8 lakon(*)
      character*20 matname(*),labmpc(*),sideload(*)
      character*21 set(*),prset(*),cbody(*)
!
      integer jinc,iamforc(*),nforc,iamload(2,*),nload,
     &  iamt1(*),nk,namta(3,*),nam,i,j,nodeboun(*),ndirboun(*),nboun,
     &  ipompc(*),nmpc,nactdof(0:3,*),iperturb,nmethod,kon(*),ne,
     &  ithermal,kode,k,l,m,jout,nodempc(3,*),nev,neq,inum(*),iprestr,
     &  ikmpc(*),ilmpc(*),ikboun(*),ilboun(*),nelcon(2,*),nrhcon(*),
     &  ndirforc(*),nelemload(2,*),nodeforc(*),nalcon(2,*),ielmat(*),
     &  ielorien(*),ntmat_,ipkon(*),norien,iout,iamboun(*),iexpl,
     &  mint_,ielas,icmd,ncmat_,nstate_,nset,istartset(*),iendset(*),
     &  ialset(*),nprint,istep,iinc,iamflow,nflow,inotr(2,*),ntrans,
     &  ipobody(3,*),ibody(2,*),nbody
      integer nplicon(0:ntmat_,*),nplkcon(0:ntmat_,*),npmat_,ncocon(2,*)
!
      real*8 b(*),z(neq,*),d(*),zeta(*),time,tinc,vold(0:3,*),
     &  xforcold(*),xforc(*),xloadold(2,*),xload(2,*),
     &  fmpc(*),xbody(7,*),xbodyold(7,*),xbodyact(7,*),
     &  t1old(*),t1(*),amta(2,*),ampli(*),aa(nev,*),bb(nev,*),
     &  v(0:3,*),xboun(*),coefmpc(*),co(3,*),stn(6,*),
     &  stx(6,mint_,*),elcon(0:ncmat_,ntmat_,*),rhcon(0:1,ntmat_,*),
     &  t0(*),h1,h2,h3,h4,h5,h6,sum,tstart,alcon(0:6,ntmat_,*),
     &  tend,aai,bbi,bj(*),cv(*),cd(*),zetaj,dj,fsub,fsuper,fcrit,ddj,
     &  prestr(6,mint_,*),eme(3,8,*),een(6,*),epn(*),
     &  sti(6,8,*),alzero(*),orab(7,*),vmax,f(*),fn(0:3,*),qa,
     &  xforcact(*),xloadact(2,*),t1act(*),reltime,
     &  xbounold(*),xbounact(*),stiini(6,mint_,*),vini(0:3,*),
     &  ener(mint_,*),enern(*),eei(6,mint_,*),enerini(mint_,*),
     &  cocon(0:6,ntmat_,*),qfx(3,mint_,*),qfn(3,*),xflowold,xflow,
     &  xflowact,trab(7,*),cgr(4,*),physcon(3)
!
      real*8 plicon(0:2*npmat_,ntmat_,*),plkcon(0:2*npmat_,ntmat_,*),
     &  xstate(nstate_,mint_,*),xstateini(nstate_,mint_,*),
     &  xstiff(21,mint_,*),xstaten(nstate_,*)
!
!     the following fields are dummy arguments for the results call
!
      real*8 veold(0:3,*),accold,bet,gam,dtime,ttime
!
      external fsub,fsuper,fcrit
!
      time=0.d0
!
!     no forced convection allowed
!
      nflow=0
!
!     calculating the instantaneous loads (forces, surface loading, 
!     centrifugal and gravity loading or temperature) at time 0
!
      call tempload(xforcold,xforc,xforcact,iamforc,nforc,xloadold,
     &  xload,xloadact,iamload,nload,ibody,xbody,nbody,xbodyold,
     &  xbodyact,t1old,t1,t1act,iamt1,nk,
     &  amta,namta,nam,ampli,time,reltime,ttime,dtime,ithermal,nmethod,
     &  xbounold,xboun,xbounact,iamboun,nboun,xflowold,xflow,xflowact,
     &  iamflow,nflow)
!
!     calculating the instantaneous loading vector at time 0
!
      call rhs(co,nk,kon,ipkon,lakon,ne,
     &  ipompc,nodempc,coefmpc,nmpc,nodeforc,ndirforc,xforcact,
     &  nforc,nelemload,sideload,xloadact,nload,xbodyact,ipobody,nbody,
     &  cgr,b,nactdof,neq,nmethod,
     &  ikmpc,ilmpc,elcon,nelcon,rhcon,nrhcon,alcon,
     &  nalcon,alzero,ielmat,ielorien,norien,orab,ntmat_,t0,t1act,
     &  ithermal,
     &  iprestr,vold,iperturb,iexpl,plicon,
     &  nplicon,plkcon,nplkcon,npmat_,ttime,time,istep,iinc,dtime,
     &  physcon)
!
      do i=1,nev
         aa(i,1)=0.d0
         do j=1,neq
            aa(i,1)=aa(i,1)+z(j,i)*b(j)
         enddo
      enddo
!
      do k=0,jinc-jout,jout
         do l=1,jout
            m=k+l
            time=m*tinc
            dtime=tinc
!
!     calculating the instantaneous loads (forces, surface loading, 
!     centrifugal and gravity loading or temperature)
!
            call tempload(xforcold,xforc,xforcact,iamforc,nforc,
     &           xloadold,xload,xloadact,iamload,nload,ibody,xbody,
     &           nbody,xbodyold,xbodyact,t1old,t1,t1act,
     &           iamt1,nk,amta,namta,nam,ampli,time,
     &           reltime,ttime,dtime,ithermal,nmethod,
     &           xbounold,xboun,xbounact,iamboun,nboun,xflowold,xflow,
     &           xflowact,iamflow,nflow)
!
!     calculating the instantaneous loading vector
!
            call rhs(co,nk,kon,ipkon,lakon,ne,
     &           ipompc,nodempc,coefmpc,nmpc,nodeforc,ndirforc,xforcact,
     &           nforc,nelemload,sideload,xloadact,nload,xbodyact,
     &           ipobody,nbody,cgr,b,nactdof,neq,nmethod,
     &           ikmpc,ilmpc,elcon,nelcon,rhcon,nrhcon,
     &           alcon,nalcon,alzero,ielmat,ielorien,norien,orab,ntmat_,
     &           t0,t1act,ithermal,
     &           iprestr,vold,iperturb,iexpl,plicon,
     &           nplicon,plkcon,nplkcon,
     &           npmat_,ttime,time,istep,iinc,dtime,physcon)
!
            do i=1,nev
               aa(i,m+1)=0.d0
               do j=1,neq
                  aa(i,m+1)=aa(i,m+1)+z(j,i)*b(j)
               enddo
               bb(i,m)=(aa(i,m+1)-aa(i,m))/tinc
               aa(i,m)=aa(i,m+1)-bb(i,m)*time
            enddo
         enddo
!
         do l=1,nev
            zetaj=zeta(l)
            dj=d(l)
!
!          subcritical damping
!
            if(zetaj.lt.1.d0-1.d-6) then
               ddj=dj*dsqrt(1.d0-zetaj*zetaj)
               h1=zetaj*dj
               h2=h1*h1+ddj*ddj
               h3=h1*h1-ddj*ddj
               h4=2.d0*h1*ddj/h2
               sum=0.d0
               do i=1,m
                  aai=aa(l,i)
                  bbi=bb(l,i)
                  tstart=time-i*tinc
                  tend=time-(i-1)*tinc
                  sum=sum+fsub(time,tend,aai,bbi,ddj,
     &                 h1,h2,h3,h4)
                  sum=sum-fsub(time,tstart,aai,bbi,ddj,
     &                 h1,h2,h3,h4)
               enddo
               bj(l)=sum/ddj+dexp(-h1*time)*(dcos(ddj*time)+zetaj/
     &              dsqrt(1.d0-zetaj*zetaj)*dsin(ddj*time))*cd(l)+
     &              dexp(-h1*time)*dsin(ddj*time)*cv(l)/ddj
!
!          supercritical damping
!
            elseif(zetaj.gt.1.d0+1.d-6) then
               ddj=dj*dsqrt(zetaj*zetaj-1.d0)
               h1=ddj-zetaj*dj
               h2=ddj+zetaj*dj
               h3=1.d0/h1
               h4=1.d0/h2
               h5=h3*h3
               h6=h4*h4
               sum=0.d0
               do i=1,m
                  aai=aa(l,i)
                  bbi=bb(l,i)
                  tstart=time-i*tinc
                  tend=time-(i-1)*tinc
                  sum=sum+fsuper(time,tend,aai,bbi,
     &                 h1,h2,h3,h4,h5,h6)
                  sum=sum-fsuper(time,tstart,aai,bbi,
     &                 h1,h2,h3,h4,h5,h6)
               enddo
               bj(l)=sum/(2.d0*ddj)+(dexp(h1*time)+dexp(-h2*time))*cd(l)
     &              /2.d0+zetaj*(dexp(h1*time)-dexp(-h2*time))/(2.d0*
     &              dsqrt(zetaj*zetaj-1.d0))*cd(l)+(dexp(h1*time)-
     &              dexp(-h2*time))*cv(l)/(2.d0*ddj)
!
!             critical damping
!
            else
               h1=zetaj*dj
               h2=1.d0/h1
               h3=h2*h2
               h4=h2*h3
               sum=0.d0
               do i=1,m
                  aai=aa(l,i)
                  bbi=bb(l,i)
                  tstart=time-i*tinc
                  tend=time-(i-1)*tinc
                  sum=sum+fcrit(time,tend,aai,bbi,zetaj,dj,ddj,
     &                 h1,h2,h3,h4)
                  sum=sum-fcrit(time,tstart,aai,bbi,zetaj,dj,ddj,
     &                 h1,h2,h3,h4)
               enddo
               bj(l)=sum+dexp(-h1*time)*
     &              ((1.d0+h1*time)*cd(l)+time*cv(l))
            endif
         enddo
!
!       composing the response
!        
         do i=1,neq
            b(i)=0.d0
            do j=1,nev
               b(i)=b(i)+bj(j)*z(i,j)
            enddo
         enddo
!
!        storing the displacement field of the one but last
!        calculation: needed for the velocity field at the start
!        of the next step
!
         if(k+jout.gt.jinc-jout) then
            do i=1,nk
               do j=0,3
                  vold(j,i)=v(j,i)
               enddo
            enddo
         endif
!
         iout=1
!
         call results(co,nk,kon,ipkon,lakon,ne,v,stn,inum,
     &        stx,elcon,nelcon,rhcon,nrhcon,alcon,nalcon,alzero,
     &        ielmat,ielorien,norien,orab,ntmat_,t0,t1,
     &        ithermal,prestr,iprestr,filab,eme,een,
     &        iperturb,f,fn,nactdof,iout,qa,
     &        vold,b,nodeboun,ndirboun,xboun,nboun,
     &        ipompc,nodempc,coefmpc,labmpc,nmpc,nmethod,vmax,neq,
     &        veold,accold,bet,gam,dtime,time,ttime,
     &        plicon,nplicon,plkcon,nplkcon,
     &        xstateini,xstiff,xstate,npmat_,epn,matname,mint_,ielas,
     &        icmd,ncmat_,nstate_,stiini,vini,ikboun,ilboun,ener,
     &        enern,sti,xstaten,eei,enerini,cocon,ncocon,
     &        set,nset,istartset,iendset,ialset,nprint,prlab,prset,
     &        qfx,qfn,trab,inotr,ntrans,fmpc)
!
         kode=kode+1
!
         ttime=ttime+jout*tinc
!
         call frd(co,nk,kon,ipkon,lakon,ne,v,stn,inum,nmethod,kode,
     &     filab,een,t1,fn,ttime,epn,ielmat,matname,enern,xstaten,
     &     nstate_,istep,iinc,ithermal,qfn,trab,inotr,ntrans,orab,
     &     ielorien,norien)
!
      enddo
!
!     determining the initial displacement and velocity field for
!     the next step
!
      do i=1,nk
         do j=0,3
            veold(j,i)=(v(j,i)-vold(j,i))/dtime
            vold(j,i)=v(j,i)
         enddo
      enddo
!
      return
      end
