/*     CalculiX - A 3-dimensional finite element program                 */
/*              Copyright (C) 1998-2005 Guido Dhondt                          */

/*     This program is free software; you can redistribute it and/or     */
/*     modify it under the terms of the GNU General Public License as    */
/*     published by the Free Software Foundation(version 2);    */
/*                                                                       */

/*     This program is distributed in the hope that it will be useful,   */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of    */ 
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the      */
/*     GNU General Public License for more details.                      */

/*     You should have received a copy of the GNU General Public License */
/*     along with this program; if not, write to the Free Software       */
/*     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         */

#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include "CalculiX.h"

void insert(int *ipointer, int *mast1, int *mast2, int *i1,
	    int *i2, int *ifree, int *nzs_){

  /*   inserts a new nonzero matrix position into the data structure */

  int idof1,idof2,istart;

  if(*i1<*i2){
    idof1=*i1;
    idof2=*i2;
  }
  else{
    idof1=*i2;
    idof2=*i1;
  }

  if(ipointer[idof2-1]==0){
    ++*ifree;
    if(*ifree>*nzs_){
      printf("*ERROR in insert: increase nzs_\n");
      stop_();
    }
    ipointer[idof2-1]=*ifree;
    mast1[*ifree-1]=idof1;
    mast2[*ifree-1]=0;
  }
  else{
    istart=ipointer[idof2-1];
    while(1){
      if(mast1[istart-1]==idof1) break;
      if(mast2[istart-1]==0){
	++*ifree;
	if(*ifree>*nzs_){
	  printf("*ERROR in insert: increase nzs_\n");
	  stop_();
	}
	mast2[istart-1]=*ifree;
	mast1[*ifree-1]=idof1;
	mast2[*ifree-1]=0;
	break;
      }
      else{
	istart=mast2[istart-1];
      }
    }
  }
  
  return;

}
	  
